// PMF_ConvertorDlg.cpp : t@C
//

#include "stdafx.h"
#include <math.h>
#include "PMF_Convertor.h"
#include "PMF_ConvertorDlg.h"
#include "dshowutil.h"
#include "..\\lib\\PMF_Header.h"
#include ".\pmf_convertordlg.h"
#include "PieceGrayConv.h"
#include "PieceMovieFileMux.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//---------------------------------------------------------------------------
// PMFptB^CLSID` 
//---------------------------------------------------------------------------

#define MYDEFINE_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
		              const GUID name \
			      = { l, w1, w2, { b1, b2,  b3,  b4,  b5,  b6,  b7,  b8 } }

// {E90ACAD1-3C09-4d6f-BAB8-D79F11570EFD}
MYDEFINE_GUID(CLSID_PieceGrayConv, 
0xe90acad1, 0x3c09, 0x4d6f, 0xba, 0xb8, 0xd7, 0x9f, 0x11, 0x57, 0xe, 0xfd);
#define PIECE_GRAY_CONV			L"P/ECE Gray Convertor"

// {5AA199C0-DF0F-4eba-9288-6FB8F939E33D}
MYDEFINE_GUID(CLSID_PieceADPCMConv, 
0x5aa199c0, 0xdf0f, 0x4eba, 0x92, 0x88, 0x6f, 0xb8, 0xf9, 0x39, 0xe3, 0x3d);
#define PIECE_ADPCM_CONV		L"P/ECE ADPCM Convertor"

// {F9278E33-B8D1-4fb2-8CFC-C9615F52CB8C}
MYDEFINE_GUID(CLSID_PieceMovieFileMux, 
0xf9278e33, 0xb8d1, 0x4fb2, 0x8c, 0xfc, 0xc9, 0x61, 0x5f, 0x52, 0xcb, 0x8c);
#define PIECE_MOVIE_FILE_MUX	L"P/ECE Movie File Mux"

//2005/07/27 Added by Madoka
// {24635BB7-C73A-413b-8375-D9B1F511AAA2}
MYDEFINE_GUID(IID_IPieceGrayConv, 
0x24635bb7, 0xc73a, 0x413b, 0x83, 0x75, 0xd9, 0xb1, 0xf5, 0x11, 0xaa, 0xa2);

//2005/07/31 Added by Madoka
// {77843162-E56D-41c6-92F6-89E6460F24FB}
MYDEFINE_GUID(IID_IPieceMovieFileMux, 
0x77843162, 0xe56d, 0x41c6, 0x92, 0xf6, 0x89, 0xe6, 0x46, 0xf, 0x24, 0xfb);

//---------------------------------------------------------------------------
//INIt@C̒萔
#define SETTING_SEC			_T("SETTINGS")			//ݒZNV
#define INPUT_DIR_KEY		_T("INPUT_DIR")			//ϊt@ĈtH_̃pX
#define INPUT_FILE_KEY		_T("INPUT_FILE")		//ϊt@C
#define OUTPUT_DIR_KEY		_T("OUTPUT_DIR")		//ϊtH_̃pX
#define OUTPUT_FILE_KEY		_T("OUTPUT_FILE")		//ϊt@C
#define AUTOCONTRAST_KEY	_T("AUTO_CONTRAST")		//RgXgtO(0:Ȃ 1:)
#define GAMMACORRECT_KEY	_T("GAMMA_CORRECT")		//K}␳tO(0:Ȃ 1:)

#define DEFAULT_MESSAGE	_T("t@ChbOhbvĉ")	//ϊt@C̏bZ[W
//---------------------------------------------------------------------------
//o̓IvVł̒萔
#define START_OFFSET_MAX		(60*120)	//JnItZbg̍ől
#define START_OFFSET_LIMIT		(4)			//JnItZbg̓͌
#define DEF_SAMPLE_LEN_INDEX	(4)			//ϊԂ̏l

//ϊ
double g_adSampleLen[] = { 1,2,3,4,5,10,15 };

//---------------------------------------------------------------------------


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CPMF_ConvertorDlg _CAO

//---------------------------------------------------------------------------
CPMF_ConvertorDlg::CPMF_ConvertorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPMF_ConvertorDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}
//---------------------------------------------------------------------------
void CPMF_ConvertorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PROGRESS, m_Progress);
}
//---------------------------------------------------------------------------
void CPMF_ConvertorDlg::LoadSetting(void)
{

	//Õt@C擾
	
	CWinApp *pApp = AfxGetApp();

	//JgfBNg̎擾
	char szDefaultDir[MAX_PATH+1];
	GetCurrentDirectory(MAX_PATH,szDefaultDir);

	//ݒǂݍ
	m_sInputDir     = pApp->GetProfileString(SETTING_SEC,INPUT_DIR_KEY  ,DEFAULT_MESSAGE);
	m_sInputFile    = pApp->GetProfileString(SETTING_SEC,INPUT_FILE_KEY ,"");
	m_sOutputDir    = pApp->GetProfileString(SETTING_SEC,OUTPUT_DIR_KEY ,szDefaultDir);
	m_sOutputFile   = pApp->GetProfileString(SETTING_SEC,OUTPUT_FILE_KEY,"???."PIECE_MOVIE_FILE_EXT);
	m_bAutoContrast = pApp->GetProfileInt(SETTING_SEC,AUTOCONTRAST_KEY,FALSE);	//2005/07/24 Added by Madoka
	m_bGammaCorrect = pApp->GetProfileInt(SETTING_SEC,GAMMACORRECT_KEY,FALSE);	//2005/07/27 Added by Madoka

}
//---------------------------------------------------------------------------
void CPMF_ConvertorDlg::SaveSetting(void)
{
	
	//̃t@Cۑ

	CWinApp *pApp = AfxGetApp();
	
	//ݒۑ
	pApp->WriteProfileString(SETTING_SEC,INPUT_DIR_KEY  ,m_sInputDir);
	pApp->WriteProfileString(SETTING_SEC,INPUT_FILE_KEY ,m_sInputFile);
	pApp->WriteProfileString(SETTING_SEC,OUTPUT_DIR_KEY ,m_sOutputDir);
	pApp->WriteProfileString(SETTING_SEC,OUTPUT_FILE_KEY,m_sOutputFile);
	pApp->WriteProfileInt(SETTING_SEC,AUTOCONTRAST_KEY,m_bAutoContrast);		//2005/07/24 Added by Madoka
	pApp->WriteProfileInt(SETTING_SEC,GAMMACORRECT_KEY,m_bGammaCorrect);		//2005/07/27 Added by Madoka

}
//---------------------------------------------------------------------------
void CPMF_ConvertorDlg::SetFileInfo(void)
{

	//t@C̕\
	
	CString sWork;

	//̓t@C̕\
	if(m_sInputFile != "")
		sWork.Format(_T("%s%s"),m_sInputDir,m_sInputFile);
	else
		sWork = m_sInputDir;
		
	SetDlgItemText(IDC_LABEL_INPUT_FILE_PATH,sWork);

	//o̓t@C̕\
	sWork.Format(_T("%s\\%s"),m_sOutputDir,m_sOutputFile);
	SetDlgItemText(IDC_LABEL_OUTPUT_FILEPATH,sWork);

}
//---------------------------------------------------------------------------    
HRESULT CPMF_ConvertorDlg::AddFilterByCLSID(IGraphBuilder *pGraph,  // tB^ Ot }l[Wւ̃|C^
											const GUID& clsid,      // 쐬tB^ CLSID
											LPCWSTR wszName,        // tB^̖O
											IBaseFilter **ppF)      // tB^ւ̃|C^󂯎
{

	//w̃tB^̃CX^X쐬ăOtɒǉ

	//|C^`FbN
    if (!pGraph || ! ppF) return E_POINTER;
    
	//w̃tB^̃CX^X쐬
	*ppF = 0;
    IBaseFilter *pF = 0;
    HRESULT hr = CoCreateInstance(clsid, 0, CLSCTX_INPROC_SERVER,
								  IID_IBaseFilter, reinterpret_cast<void**>(&pF));
    
	//쐬ɐH
	if (SUCCEEDED(hr))
    {
		//OtɃtB^ǉ
        hr = pGraph->AddFilter(pF,wszName);
        if (SUCCEEDED(hr))
            *ppF = pF;
        else
            pF->Release();
    }

    return hr;
}
//---------------------------------------------------------------------------
void CPMF_ConvertorDlg::PumpMessages(void)
{
	//IɃbZ[W

    MSG msg;

    while(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }
}
//---------------------------------------------------------------------------
void CPMF_ConvertorDlg::ShowProcessTime(char *pszMessage,int nTime)
{

	//bZ[WxɌoߎԂ\

	CString sProgressText;
	int nHour   = nTime / 3600; nTime %= 3600;
	int nMinute = nTime / 60;   nTime %= 60;
	int nSecond = nTime;

	sProgressText.Format(_T("%s oߎ %02d:%02d:%02d"),
						 pszMessage,nHour,nMinute,nSecond);
	SetDlgItemText(IDC_LABEL_MESSAGE,sProgressText);

}
//---------------------------------------------------------------------------
BOOL CPMF_ConvertorDlg::ShowMediaInfo(void)
{

	//fBA̕\

	BOOL bRet = FALSE;

	//̓t@CpX擾
	CString sInputPath;

	GetDlgItemText(IDC_LABEL_INPUT_FILE_PATH,sInputPath);
	
	//TCY`FbN
	if(sInputPath.GetLength() > (MAX_PATH - 1))
	{
		AfxMessageBox(_T("̓pX܂"),MB_ICONEXCLAMATION);
		return bRet;
	}
	
	//pX̕Unicodeɕϊ
	USES_CONVERSION;
	TCHAR *ptFilename = sInputPath.GetBuffer(MAX_PATH);
	WCHAR *pwFilename = T2W(ptFilename);

	//Xg[p\tO
	m_bUseVideo = FALSE;
	m_bUseAudio = FALSE;

	//fBA
	SetDlgItemText(IDC_LABEL_MEDIA_INFO,"fBA擾...");
	
	//IMediaDetC^[tF[Xɂ胁fBȀ擾
	CString sMediaInfo = "fBA񂪎擾ł܂ł";
			
	//IMediaDetC^[tF[X̃CX^X𐶐
	CComPtr<IMediaDet> pMediaDet;
	
	pMediaDet.CoCreateInstance(CLSID_MediaDet);
	if(!pMediaDet)
	{
		AfxMessageBox(_T("IMediaDetC^[tF[X̃CX^X쐬Ɏs"),MB_ICONEXCLAMATION);
		return bRet;
	}

	//fBÃt@CZbg
	if(SUCCEEDED(pMediaDet->put_Filename(pwFilename)))
	{
		//fBÃXg[擾
		long lStreamNum;
		if(SUCCEEDED(pMediaDet->get_OutputStreams(&lStreamNum)))
		{
			//Video܂AudiõXg[݂邩H
			if(lStreamNum > 0)
			{
				//Xg[̕obt@p
				CString *pasStreamInfo = new CString[lStreamNum];

				//Xg[ăfBA擾
				sMediaInfo = "";
				int i;
				for(i = 0;i < lStreamNum;++i)
				{
					//JgXg[w
					pMediaDet->put_CurrentStream(i);

					//Xg[擾
					pasStreamInfo[i] = "fBA񂪎擾ł܂";	//擾Ɏs̕\
					GetStreamInfoStr(pasStreamInfo[i],pMediaDet);		

					//fBAZ
					CString sStream;
					sStream.Format(_T("Xg[%d %s\n\n"),i+1,pasStreamInfo[i]);
				    
					sMediaInfo += sStream;
				}

				//Xg[폜
				delete[] pasStreamInfo;

				//Video͗p\H
				if(m_bUseVideo)
				{
					//Ɏ擾܂
					bRet = TRUE;
				}
			}
		}	
	}

	//fBA\
	SetDlgItemText(IDC_LABEL_MEDIA_INFO,sMediaInfo);
			
	return bRet;
}
//---------------------------------------------------------------------------
void CPMF_ConvertorDlg::GetStreamInfoStr(CString &sStreamInfo,IMediaDet *pMediaDet)
{

	//Xg[̏擾

	GUID StreamGuid;
	REFTIME rtLength;
	
	//̏
	sStreamInfo = "";

	//fBA^Cv𒲂ׂ
	pMediaDet->get_StreamType(&StreamGuid);

	//rfIXg[H
	if(StreamGuid == MEDIATYPE_Video)
	{
		//ĐԂ̎擾
        CString sLength;
		pMediaDet->get_StreamLength(&rtLength);
		
		int nTime   = (int)rtLength;
		int nHour   = nTime / 3600; nTime %= 3600;
		int nMinute = nTime / 60;   nTime %= 60;
		int nSecond = nTime;

		sLength.Format(_T("rfI̍Đ %02d:%02d:%02d"),
					   nHour,nMinute,nSecond);
        
		//2005/07/31 Added by Madoka
		//rfI̍ĐԂ15fpsł̃rfIt[
		//Zo(̏ꍇAbPʂ܂ł킩Ȃ̂ŁA
		//t[̐x15PʂɂȂĂ܂܂Av
		//OXo[Őis󋵂\邽߂ɎgȂ̂
		//ɖ肠܂)B
		m_dwTotalFrames = (DWORD)rtLength * 15;

		//fBA擾
		AM_MEDIA_TYPE tMediaType;
		if(SUCCEEDED(pMediaDet->get_StreamMediaType(&tMediaType)))
		{
			VIDEOINFOHEADER *pVideoInfo
			 = (VIDEOINFOHEADER*)tMediaType.pbFormat;

			//摜̋`擾
			CString sRect;
			sRect.Format(_T("ʃTCY %dx%d"),
						 pVideoInfo->bmiHeader.biWidth,
						 pVideoInfo->bmiHeader.biHeight);

			//t[[g擾
			//̂ɂĂFPS擾łȂt@C
			//  悤łBȃt@C̏ꍇAǂ
			//  Ď擾΂͕̂܂(--;
			CString sFrameRate;
			double dFrameRate;
			pMediaDet->get_FrameRate(&dFrameRate);			
			sFrameRate.Format(_T("FPS %lf"),dFrameRate);
			
			//A
			sStreamInfo.Format(_T("%s\n%s\n%s"),sLength,sRect,sFrameRate);

			//Đԃ`FbN
			if((nHour + nMinute + nSecond) > 0)
			{
				//Video͗p\H
				BSTR pInputFile;
				pMediaDet->get_Filename(&pInputFile);
				if(CheckVideoDecode(pInputFile))
				{
					//Video͗p\ł
					m_bUseVideo = TRUE;
				}
				else
				{
					//VideopsȎ|\
					sStreamInfo += "\ñXg[̓T|[gOł ϊł܂ R[fbNKvł";
				}
				SysFreeString(pInputFile);
			}
			else
			{
				//VideopsȎ|\
				sStreamInfo += "\nĐԂ0Ȃ̂ŁÃXg[̓T|[gOł ϊł܂";
			}
		}
	}
	//I[fBIXg[H
	else if(StreamGuid == MEDIATYPE_Audio)			
	{
		//ĐԂ̎擾
        CString sLength;
		pMediaDet->get_StreamLength(&rtLength);
		
		int nTime   = (int)rtLength;
		int nHour   = nTime / 3600; nTime %= 3600;
		int nMinute = nTime / 60;   nTime %= 60;
		int nSecond = nTime;

		sLength.Format(_T("I[fBI̍Đ %02d:%02d:%02d"),
					   nHour,nMinute,nSecond);
        
		//fBA擾
		AM_MEDIA_TYPE tMediaType;
		if(SUCCEEDED(pMediaDet->get_StreamMediaType(&tMediaType)))
		{
			WAVEFORMATEX *pAudioInfo
			 = (WAVEFORMATEX*)tMediaType.pbFormat;

			//擾
			CString sAudioInfo;
			sAudioInfo.Format(_T("%dHz %dbit %dch."),
							  pAudioInfo->nSamplesPerSec,
							  pAudioInfo->wBitsPerSample,
							  pAudioInfo->nChannels);							  

			//A
			sStreamInfo.Format(_T("%s\n%s"),sLength,sAudioInfo);

			//Đԃ`FbN
			if((nHour + nMinute + nSecond) > 0)
			{
				//Audio͗p\H
				BSTR pInputFile;
				pMediaDet->get_Filename(&pInputFile);
				if(CheckAudioDecode(pInputFile))
				{
					//Audio͗p\ł
					m_bUseAudio = TRUE;
				}
				else
				{
					//AudiopsȎ|\
					sStreamInfo += "\ñXg[̓T|[gOł ϊł܂ R[fbNKvł";
				}
				SysFreeString(pInputFile);			
			}
			else
			{
				//AudiopsȎ|\
				sStreamInfo += "\nĐԂ0Ȃ̂ŁÃXg[̓T|[gOł ϊł܂";
			}
		}
	}
	//̑
	else
	{
		sStreamInfo = "̑";
	}
}
//---------------------------------------------------------------------------
BOOL CPMF_ConvertorDlg::CheckVideoDecode(BSTR InputFilePath)
{

	//VideoXg[̃fR[h`FbN

	HRESULT hr;

	//tB^Ot(GraphEdit̐}̃C[W)쐬
    CComPtr<IGraphBuilder> pGraph;
    pGraph.CoCreateInstance(CLSID_FilterGraph);
    if(!pGraph)
    {
        AfxMessageBox(_T("tB^Ot̐Ɏs܂"),MB_ICONSTOP);
        return FALSE;
    }

    //Lv`Otr_[ƂtB^[Ot̐ڑȂǂ
	//T|[gĂe쐬
	CComPtr<ICaptureGraphBuilder> pBuilder;
    pBuilder.CoCreateInstance(CLSID_CaptureGraphBuilder);

	//Lv`Otr_[ɎgptB^OtZbg
    hr = pBuilder->SetFiltergraph(pGraph);
    if(FAILED(hr))
    {
        AfxMessageBox(_T("Lv`Otr_[̃ZbgAbvɎs܂"),MB_ICONSTOP);
        return FALSE;
    }


    //w̃t@CJ߂̃\[XtB^tB^[Otɒǉ
	CComPtr<IBaseFilter> pSourceBase;
    hr = pGraph->AddSourceFilter(InputFilePath, L"Source", &pSourceBase);
    if(!pSourceBase)
    {
        AfxMessageBox(_T("\[XtB^̒ǉɎs܂"),MB_ICONSTOP);
        return FALSE;
    }

	//P/ECE Gray ConvertorOtɒǉ
	CComPtr<IBaseFilter> pPieceGrayConv;
	hr = AddFilterByCLSID(pGraph,CLSID_PieceGrayConv,PIECE_GRAY_CONV,&pPieceGrayConv);
	if(FAILED(hr))
	{
	    AfxMessageBox(_T("P/ECE Gray ConvertortB^̒ǉɎs܂"),MB_ICONSTOP);
        return FALSE;
	}

	//etB^̓/o̓s擾Aڑ݂
	CComPtr<IPin> pVideoIn = GetInPin(pPieceGrayConv,0); 
	BOOL bRet = FALSE;
	int n = 0;
	CComPtr<IPin> pSourceOut = GetOutPin(pSourceBase,n);
    
	while(pSourceOut != NULL)
	{
		//\[XtB^P/ECE Gray Convertorڑ
		//CeWFgڑɂAIɊԂɕKvȃtB^
		//}܂B
		hr = pGraph->Connect(pSourceOut,pVideoIn);
    	if(SUCCEEDED(hr))
		{
			//Video͗p\ł
			bRet = TRUE;
			break;
		}
		
		//̃s
		n++;
		pSourceOut = GetOutPin(pSourceBase,n);
	}

	return bRet;
}
//---------------------------------------------------------------------------
BOOL CPMF_ConvertorDlg::CheckAudioDecode(BSTR InputFilePath)
{

	//AudioXg[̃fR[h`FbN

	HRESULT hr;

	//tB^Ot(GraphEdit̐}̃C[W)쐬
    CComPtr<IGraphBuilder> pGraph;
    pGraph.CoCreateInstance(CLSID_FilterGraph);
    if(!pGraph)
    {
        AfxMessageBox(_T("tB^Ot̐Ɏs܂"),MB_ICONSTOP);
        return FALSE;
    }

    //Lv`Otr_[ƂtB^[Ot̐ڑȂǂ
	//T|[gĂe쐬
	CComPtr<ICaptureGraphBuilder> pBuilder;
    pBuilder.CoCreateInstance(CLSID_CaptureGraphBuilder);

	//Lv`Otr_[ɎgptB^OtZbg
    hr = pBuilder->SetFiltergraph(pGraph);
    if(FAILED(hr))
    {
        AfxMessageBox(_T("Lv`Otr_[̃ZbgAbvɎs܂"),MB_ICONSTOP);
        return FALSE;
    }

    //w̃t@CJ߂̃\[XtB^tB^[Otɒǉ
	CComPtr<IBaseFilter> pSourceBase;
    hr = pGraph->AddSourceFilter(InputFilePath, L"Source", &pSourceBase);
    if(!pSourceBase)
    {
        AfxMessageBox(_T("\[XtB^̒ǉɎs܂"),MB_ICONSTOP);
        return FALSE;
    }

	//P/ECE ADPCM ConvertorOtɒǉ
	CComPtr<IBaseFilter> pPieceADPCMConv;
	hr = AddFilterByCLSID(pGraph,CLSID_PieceADPCMConv,PIECE_ADPCM_CONV,&pPieceADPCMConv);
	if(FAILED(hr))
	{
	    AfxMessageBox(_T("P/ECE ADPCM ConvertortB^̒ǉɎs܂"),MB_ICONSTOP);
        return FALSE;
	}

	//etB^̓/o̓s擾Aڑ݂
	CComPtr<IPin> pAudioIn = GetInPin(pPieceADPCMConv,0); 
	BOOL bRet = FALSE;
	int n = 0;
	CComPtr<IPin> pSourceOut = GetOutPin(pSourceBase,n);
    
	while(pSourceOut != NULL)
	{
		//\[XtB^P/ECE ADPCM Convertorڑ
		//CeWFgڑɂAIɊԂɕKvȃtB^
		//}܂B
		hr = pGraph->Connect(pSourceOut,pAudioIn);
    	if(SUCCEEDED(hr))
		{
			//Audio͗p\ł
			bRet = TRUE;
			break;
		}
		
		//̃s
		n++;
		pSourceOut = GetOutPin(pSourceBase,n);
	}

	return bRet;
}
//---------------------------------------------------------------------------
void CPMF_ConvertorDlg::InitOutOption(void)
{

	//o̓IvV̏

	//eȍ
	m_dStartOffset    = 0;
	m_bSampleOut      = FALSE;
	m_nSampleLenIndex = DEF_SAMPLE_LEN_INDEX;

	//eRg[

	//Xs{^Rg[ɔ͈͂ݒ
	CSpinButtonCtrl	*pSpin = (CSpinButtonCtrl*)GetDlgItem(IDC_SPIN_OUT_OFFSET);
	pSpin->SetRange32(0,START_OFFSET_MAX);
	
	//JnItZbg
	CEdit *pEdit = (CEdit*)GetDlgItem(IDC_EDIT_OUT_OFFSET);
	pEdit->SetLimitText(START_OFFSET_LIMIT);	//͌𐧌
	pEdit->SetWindowText("0");		

	//ϊ`FbNNA
	CButton *pCheck = (CButton*)GetDlgItem(IDC_CHECK_OUT_SAMPLE_LEN);
	pCheck->SetCheck(BST_UNCHECKED);

	//ϊ̎Ԃ
	CComboBox *pCombo = (CComboBox*)GetDlgItem(IDC_COMBO_SAMPLE_LEN);
	pCombo->SetCurSel(m_nSampleLenIndex);

	//ŏ͐GȂ悤ɂ
	pCombo->EnableWindow(FALSE);

	//2005/07/24 Added by Madoka
	//RgXgtȌ
	pCheck = (CButton*)GetDlgItem(IDC_CHECK_AUTO_CONTRAST);
	pCheck->SetCheck((m_bAutoContrast == TRUE) ? BST_CHECKED : BST_UNCHECKED);

	//2005/07/27 Added by Madoka
	//K}␳tȌ
	pCheck = (CButton*)GetDlgItem(IDC_CHECK_GAMMA_CORRECT);
	pCheck->SetCheck((m_bGammaCorrect == TRUE) ? BST_CHECKED : BST_UNCHECKED);

	//2005/07/31 Added by Madoka
	//K}␳̒l萔擾ĕ\
	CString sGammaCaption;
	sGammaCaption.Format(_T("K}␳(%4.2f)"),GAMMA_VALUE);
	pCheck->SetWindowText(sGammaCaption);

}
//---------------------------------------------------------------------------
void CPMF_ConvertorDlg::GetOutOptionValue(void)
{

	//o̓IvV̒l擾

	//ϊJnItZbg擾
	m_dStartOffset = (double)GetDlgItemInt(IDC_EDIT_OUT_OFFSET);

	//ϊ`FbN擾
	CButton *pCheck = (CButton*)GetDlgItem(IDC_CHECK_OUT_SAMPLE_LEN);
	m_bSampleOut = (pCheck->GetCheck() == BST_CHECKED) ? TRUE : FALSE;

	//ϊԂ擾
	CComboBox *pComb = (CComboBox*)GetDlgItem(IDC_COMBO_SAMPLE_LEN);
    m_nSampleLenIndex = pComb->GetCurSel();

	//2005/07/24 Added by Madoka
	//RgXgtO擾
	pCheck = (CButton*)GetDlgItem(IDC_CHECK_AUTO_CONTRAST);
	if(pCheck->GetCheck() == BST_CHECKED)
		m_bAutoContrast = TRUE;
	else
		m_bAutoContrast = FALSE;

	//2005/07/27 Added by Madoka
	//K}␳tO擾
	pCheck = (CButton*)GetDlgItem(IDC_CHECK_GAMMA_CORRECT);
	if(pCheck->GetCheck() == BST_CHECKED)
		m_bGammaCorrect = TRUE;
	else
		m_bGammaCorrect = FALSE;

}
//---------------------------------------------------------------------------



BEGIN_MESSAGE_MAP(CPMF_ConvertorDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DROPFILES()
	ON_BN_CLICKED(IDC_BUTTON_RUN, OnBnClickedButtonRun)
	ON_BN_CLICKED(IDC_BUTTON_OUTDIR, OnBnClickedButtonOutdir)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_CHECK_OUT_SAMPLE_LEN, OnBnClickedCheckOutSampleLen)
	ON_EN_CHANGE(IDC_EDIT_OUT_OFFSET, OnEnChangeEditOutOffset)
END_MESSAGE_MAP()


// CPMF_ConvertorDlg bZ[W nh

BOOL CPMF_ConvertorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B

	//COM̏
	CoInitializeEx(NULL, COINIT_APARTMENTTHREADED);
	
	//Xg[p\tO
	m_bUseVideo = FALSE;
	m_bUseAudio = FALSE;

	//c[qgRg[Ɋ蓖
	m_tooltip.Create(this);
    m_tooltip.AddTool(GetDlgItem(IDC_LABEL_INPUT_FILE_PATH),_T("t@ChbOhbvĂ"));

	//2005/04/08 Add by Madoka
	//tȌ
	m_bInternalEdit = FALSE;
		
	//ItȌ
	m_bCloseRequested = FALSE;

	//2005/07/31 Added by Madoka
	//󋵕\vOXo[͈̔͂100ɐݒ
	m_Progress.SetRange(0,100);
	
	//2005/07/31 Added by Madoka
	//rfIt[
	m_dwTotalFrames = 0;

	//Õt@C擾
	LoadSetting();

	//o̓IvV̏
	InitOutOption();

	//̓t@C邩H
	if(m_sInputFile != "")
	{
		//t@C\
		SetFileInfo();

		//ϊJn{^񗘗ps
		GetDlgItem(IDC_BUTTON_RUN)->EnableWindow(FALSE);
		GetDlgItem(IDC_CHECK_AUTO_CONTRAST)->EnableWindow(FALSE);		//2005/07/24 Added by Madoka
		GetDlgItem(IDC_CHECK_GAMMA_CORRECT)->EnableWindow(FALSE);		//2005/07/27 Added by Madoka

		//fBA\
		if(ShowMediaInfo())
		{
			//ϊJn{^𗘗p\
			GetDlgItem(IDC_BUTTON_RUN)->EnableWindow(TRUE);
			GetDlgItem(IDC_CHECK_AUTO_CONTRAST)->EnableWindow(TRUE);	//2005/07/24 Added by Madoka
			GetDlgItem(IDC_CHECK_GAMMA_CORRECT)->EnableWindow(TRUE);	//2005/07/27 Added by Madoka
		}
	}
		
	//t@C̃hbvtJn
	DragAcceptFiles(TRUE);

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CPMF_ConvertorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CPMF_ConvertorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//[U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CPMF_ConvertorDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CPMF_ConvertorDlg::OnDropFiles(HDROP hDropInfo)
{	
	//hbOhbvꂽt@C̃pX擾
	TCHAR szFilePath[MAX_PATH+1];

	//ŏ1擾
	if(DragQueryFile(hDropInfo,0,szFilePath,MAX_PATH) > 0)
	{
		//tH_ƃt@CɕĎ擾
		TCHAR szDrive[MAX_PATH];
		TCHAR szDir[MAX_PATH];
		TCHAR szFile[MAX_PATH];
		TCHAR szExt[MAX_PATH];

		_tsplitpath(szFilePath,szDrive,szDir,szFile,szExt);

		m_sInputDir.Format(_T("%s%s"),szDrive,szDir);
		m_sInputFile.Format(_T("%s%s"),szFile,szExt);

		//ϊt@C
		m_sOutputFile.Format(_T("%s.%s"),szFile,PIECE_MOVIE_FILE_EXT);
	}

	//t@Cۑ
	SaveSetting();

	//ϊIbZ[W\
	SetDlgItemText(IDC_LABEL_MESSAGE,"");

	//ʂɕ\
	SetFileInfo();

	//ϊJn{^񗘗ps
	GetDlgItem(IDC_BUTTON_RUN)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK_AUTO_CONTRAST)->EnableWindow(FALSE);		//2005/07/24 Added by Madoka
	GetDlgItem(IDC_CHECK_GAMMA_CORRECT)->EnableWindow(FALSE);		//2005/07/27 Added by Madoka

	//fBA\
	if(ShowMediaInfo())
	{
		//ϊJn{^𗘗p\
		GetDlgItem(IDC_BUTTON_RUN)->EnableWindow(TRUE);
		GetDlgItem(IDC_CHECK_AUTO_CONTRAST)->EnableWindow(TRUE);	//2005/07/24 Added by Madoka
		GetDlgItem(IDC_CHECK_GAMMA_CORRECT)->EnableWindow(TRUE);	//2005/07/27 Added by Madoka
	}	

    CDialog::OnDropFiles(hDropInfo);

}

void CPMF_ConvertorDlg::OnBnClickedButtonRun()
{
	//ϊJn

	HRESULT hr = 0;

	do
	{
		//o͐tH_ύX{^𗘗ps
		GetDlgItem(IDC_BUTTON_OUTDIR)->EnableWindow(FALSE);
		
		//ϊJn{^𗘗ps
		GetDlgItem(IDC_BUTTON_RUN)->EnableWindow(FALSE);
		GetDlgItem(IDC_CHECK_AUTO_CONTRAST)->EnableWindow(FALSE);	//2005/07/24 Added by Madoka
		GetDlgItem(IDC_CHECK_GAMMA_CORRECT)->EnableWindow(FALSE);	//2005/07/27 Added by Madoka

		//ϊ̓t@C̃hbv󂯕tȂ
		DragAcceptFiles(FALSE);

		//ϊbZ[W̏
		SetDlgItemText(IDC_LABEL_MESSAGE,"");

		//2005/07/31 Added by Madoka
		//ϊ󋵃vOXo[ĕ\
		m_Progress.SetPos(0);
		m_Progress.ShowWindow(SW_SHOW);

		//̓t@CpXƏo̓t@CpX擾
		CString sInputPath,sOutputPath;

		GetDlgItemText(IDC_LABEL_INPUT_FILE_PATH,sInputPath);
		GetDlgItemText(IDC_LABEL_OUTPUT_FILEPATH,sOutputPath);

		//TCY`FbN
		if(sInputPath.GetLength() > (MAX_PATH - 1))
		{
			AfxMessageBox(_T("̓pX܂"),MB_ICONEXCLAMATION);
			break;
		}
		if(sOutputPath.GetLength() > (MAX_PATH - 1))
		{
			AfxMessageBox(_T("o̓pX܂"),MB_ICONEXCLAMATION);
			break;
		}

		//pX̕Unicodeɕϊ
		USES_CONVERSION;
		TCHAR *ptFilename = sInputPath.GetBuffer(MAX_PATH);
		WCHAR *pwFilename = T2W(ptFilename);
	    
		//o̓IvV̒l擾
		GetOutOptionValue();


		//==========================================================================
		//t[[gϊpɃ^CC쐬
		//==========================================================================
		CComPtr< IRenderEngine >  pRenderEngine;	//{_OGW
		CComPtr< IGraphBuilder >  pGraph;			//tB^Ot
		CComPtr< IAMTimeline >    pTimeline;		//^CC
		CComPtr< IAMTimelineObj > pVideoGroupObj;	//rfIO[v
		CComPtr< IAMTimelineObj > pAudioGroupObj;	//I[fBIO[v

		//^CC̍쐬
		//(IAMTimelineC^[tF[X̃CX^X쐬)
		//
		//̃^CCɁArfIO[vƃI[fBIO[v
		//쐬AꂼɃgbN}A\[XƂă[r[
		//t@C荞݂܂B
		//
		//̊֌WAbodePremireUleadVideoStudioȂǂ
		//ҏW\tg̉ʂvoĂ炦΁AC[Wł
		//Ǝv܂B
		hr = CoCreateInstance(CLSID_AMTimeline, 
							  NULL,CLSCTX_INPROC_SERVER, 
							  IID_IAMTimeline,(void**)&pTimeline);

		if(FAILED(hr))
		{
			AfxMessageBox(_T("^CC̍쐬Ɏs܂"),MB_ICONSTOP);
			break;
		}

		//rfIO[v̍쐬
		hr = pTimeline->CreateEmptyNode(&pVideoGroupObj,TIMELINE_MAJOR_TYPE_GROUP);
		if(FAILED(hr)) 
		{
			AfxMessageBox(_T("rfIO[vIuWFNg̍쐬Ɏs܂"),MB_ICONSTOP);
			break;
		}
	    
		//fBA^CvrfIƂĐݒ
		CComQIPtr<IAMTimelineGroup,&IID_IAMTimelineGroup> pVideoGroup(pVideoGroupObj);
		CMediaType VideoGroupType;
		
		VideoGroupType.SetType(&MEDIATYPE_Video);
		hr = pVideoGroup->SetMediaType(&VideoGroupType);
		if(FAILED(hr)) 
		{
			AfxMessageBox(_T("rfIO[ṽfBA^CvݒɎs܂"),MB_ICONSTOP);
			break;
		}

		//rfIFPSIɐݒ
		pVideoGroup->SetOutputFPS(PMF_FPS);

		//^CCɃrfIO[vǉ
		hr = pTimeline->AddGroup(pVideoGroupObj);
		if(FAILED(hr)) 
		{
			AfxMessageBox(_T("rfIO[v̒ǉɎs܂"),MB_ICONSTOP);
			break;
		}

		//rfIgbN̍쐬
		CComPtr<IAMTimelineObj> pVideoTrackObj;
		hr = pTimeline->CreateEmptyNode(&pVideoTrackObj,TIMELINE_MAJOR_TYPE_TRACK);
		if(FAILED(hr)) 
		{
			AfxMessageBox(_T("rfIgbN̍쐬Ɏs܂"),MB_ICONSTOP);
			break;
		}

		//rfIO[v獇SIAMTimelineCompC^[tF[X
		//擾AgbN}w
		CComQIPtr< IAMTimelineComp, &IID_IAMTimelineComp > pVideoComp(pVideoGroupObj);
		hr = pVideoComp->VTrackInsBefore(pVideoTrackObj,-1);
		if(FAILED(hr)) 
		{
			AfxMessageBox(_T("rfIgbN̑}Ɏs܂"),MB_ICONSTOP);
			break;
		}
	    
		//IMediaDetC^[tF[Xɂ胁fBA̍ĐԂ擾

		//IMediaDetC^[tF[X̃CX^X𐶐
		REFERENCE_TIME TLStop,TLMediaStart,TLMediaStop;
		CComPtr<IMediaDet> pMediaDet;
		
		pMediaDet.CoCreateInstance(CLSID_MediaDet);
		if(!pMediaDet)
		{
			AfxMessageBox(_T("IMediaDetC^[tF[X̃CX^X쐬Ɏs܂"),MB_ICONSTOP);
			break;
		}

		//fBÃt@CZbg
		pMediaDet->put_Filename(pwFilename);
		
		//fBÃXg[擾
		long lStreamNum;
		pMediaDet->get_OutputStreams(&lStreamNum);

		//Xg[āArfIƃI[fBI̍Đ(b)擾
		REFTIME rtVideoLen = 0;
		REFTIME rtAudioLen = 0;
		int i;
		for(i = 0;i < lStreamNum;++i)
		{
			//JgXg[w
			pMediaDet->put_CurrentStream(i);

			//fBA^Cv𒲂ׂ
			GUID StreamGuid;
			pMediaDet->get_StreamType(&StreamGuid);

			if(StreamGuid == MEDIATYPE_Video)
				pMediaDet->get_StreamLength(&rtVideoLen);
			else if(StreamGuid == MEDIATYPE_Audio)			
				pMediaDet->get_StreamLength(&rtAudioLen);				
		}

		//rfI\[XIuWFNg̍쐬
		CComPtr<IAMTimelineObj> pVideoSourceObj;
		hr = pTimeline->CreateEmptyNode(&pVideoSourceObj,TIMELINE_MAJOR_TYPE_SOURCE);
		if(FAILED( hr )) 
		{
			AfxMessageBox(_T("rfI\[XIuWFNg̍쐬Ɏs܂"),MB_ICONSTOP);
			break;
		}

		//IAMTimelineSrcC^[tF[X(\[XpC^[tF[X)
		//擾A\[X̃t@Cƕϊ̑ΏۂƂ鎞ԕZbg
		CComQIPtr< IAMTimelineSrc, &IID_IAMTimelineSrc > pVideoSourceSrc( pVideoSourceObj );
		hr = pVideoSourceSrc->SetMediaName(pwFilename);
		if(FAILED( hr )) 
		{
			AfxMessageBox(_T("rfI\[X̃t@CZbgɎs܂"),MB_ICONSTOP);
			break;
		}

		//ϊJnItZbg̃`FbN
		if(m_dStartOffset >= floor(rtVideoLen))
		{
			AfxMessageBox(_T("ϊJnItZbgrfI̍ĐԂ𒴂Ă܂"),MB_ICONSTOP);
			break;	
		}

		//ϊJñfBA^C쐬
		TLMediaStart = (REFERENCE_TIME)m_dStartOffset * UNITS;

		//ϊ̂H
		if(m_bSampleOut)
		{
			double dStopTime = m_dStartOffset + g_adSampleLen[m_nSampleLenIndex];
			
			//ԂfBA̍Ōɍ킹
			if(dStopTime > rtVideoLen)
				dStopTime = rtVideoLen;
			
			TLStop = (REFERENCE_TIME)(dStopTime - m_dStartOffset) * UNITS;	//^CC
			TLMediaStart = (REFERENCE_TIME)m_dStartOffset * UNITS;			//fBA^C()
			TLMediaStop  = (REFERENCE_TIME)dStopTime      * UNITS;			//fBA^C(܂)
		}
		else
		{
			TLStop = (REFERENCE_TIME)(rtVideoLen - m_dStartOffset) * UNITS;	//^CC(ϊJnItZbg烁fBA̍Ō܂)
			TLMediaStart = (REFERENCE_TIME)m_dStartOffset * UNITS;			//fBA^C()
			TLMediaStop  = (REFERENCE_TIME)rtVideoLen     * UNITS;			//fBA^C(܂)
		}

		//ϊԎw
		hr  = pVideoSourceObj->SetStartStop(0,TLStop);					//^CCԂw
		hr |= pVideoSourceSrc->SetMediaTimes(TLMediaStart,TLMediaStop);	//fBA^Cw
	    
		//\[XgbNɒǉ
		CComQIPtr< IAMTimelineTrack, &IID_IAMTimelineTrack > pVideoTrack( pVideoTrackObj );
		hr = pVideoTrack->SrcAdd( pVideoSourceObj );
		if(FAILED( hr )) 
		{
			AfxMessageBox(_T("rfIgbNւ̃\[XǉɎs܂"),MB_ICONSTOP);
			break;
		}


		//I[fBIO[v̍쐬
		hr = pTimeline->CreateEmptyNode(&pAudioGroupObj,TIMELINE_MAJOR_TYPE_GROUP);
		ASSERT(!FAILED(hr));

		//fBA^CvI[fBIƂĐݒ
		CComQIPtr< IAMTimelineGroup, &IID_IAMTimelineGroup > pAudioGroup(pAudioGroupObj);
		CMediaType AudioGroupType;

		AudioGroupType.SetType(&MEDIATYPE_Audio);
		hr = pAudioGroup->SetMediaType(&AudioGroupType);
		ASSERT(!FAILED(hr));

		//^CCɃI[fBIO[vǉ
		hr = pTimeline->AddGroup(pAudioGroupObj);
		ASSERT(!FAILED(hr));

		//I[fBIgbN̍쐬
		CComPtr< IAMTimelineObj > pAudioTrackObj;
		hr = pTimeline->CreateEmptyNode(&pAudioTrackObj, TIMELINE_MAJOR_TYPE_TRACK);
		ASSERT(!FAILED(hr));

		//I[fBIO[v獇SIAMTimelineCompC^[tF[X
		//擾AgbN}w
		CComQIPtr< IAMTimelineComp, &IID_IAMTimelineComp > pAudioComp(pAudioGroupObj);
		hr = pAudioComp->VTrackInsBefore(pAudioTrackObj,-1);
		ASSERT(!FAILED(hr));

		//I[fBI\[XIuWFNg̍쐬
		CComPtr<IAMTimelineObj> pAudioSourceObj;
		hr = pTimeline->CreateEmptyNode(&pAudioSourceObj,TIMELINE_MAJOR_TYPE_SOURCE);
		ASSERT(!FAILED(hr));

		//IAMTimelineSrcC^[tF[X(\[XpC^[tF[X)
		//擾A\[X̃t@Cƕϊ̑ΏۂƂ鎞ԕZbg
		CComQIPtr< IAMTimelineSrc, &IID_IAMTimelineSrc > pAudioSourceSrc(pAudioSourceObj);
		hr = pAudioSourceSrc->SetMediaName(pwFilename);
		ASSERT(!FAILED(hr));

		//ϊJnItZbg̃`FbN
		if(m_dStartOffset < floor(rtAudioLen))
		{
			//ϊJñfBA^C쐬
			TLMediaStart = (REFERENCE_TIME)m_dStartOffset * UNITS;

			//ϊ̂H
			if(m_bSampleOut)
			{
				double dStopTime = m_dStartOffset + g_adSampleLen[m_nSampleLenIndex];
				
				//ԂfBA̍Ōɍ킹
				if(dStopTime > rtAudioLen)
					dStopTime = rtAudioLen;
				
				TLStop = (REFERENCE_TIME)(dStopTime - m_dStartOffset) * UNITS;	//^CC
				TLMediaStart = (REFERENCE_TIME)m_dStartOffset * UNITS;			//fBA^C()
				TLMediaStop  = (REFERENCE_TIME)dStopTime      * UNITS;			//fBA^C(܂)
			}
			else
			{
				TLStop = (REFERENCE_TIME)(rtAudioLen - m_dStartOffset) * UNITS;	//^CC(ϊJnItZbg烁fBA̍Ō܂)
				TLMediaStart = (REFERENCE_TIME)m_dStartOffset * UNITS;			//fBA^C()
				TLMediaStop  = (REFERENCE_TIME)rtVideoLen     * UNITS;			//fBA^C(܂)
			}

			//ϊԎw
			hr  = pAudioSourceObj->SetStartStop(0,TLStop);					//^CCԂw
			hr |= pAudioSourceSrc->SetMediaTimes(TLMediaStart,TLMediaStop);	//fBA^Cw
		    
			//\[XgbNɒǉ
			CComQIPtr< IAMTimelineTrack, &IID_IAMTimelineTrack > pAudioTrack(pAudioTrackObj);
			hr = pAudioTrack->SrcAdd(pAudioSourceObj);
			ASSERT(!FAILED(hr));

			//\[X̊mF
			hr = pTimeline->ValidateSourceNames(SFN_VALIDATEF_CHECK | SFN_VALIDATEF_POPUP |
												SFN_VALIDATEF_REPLACE,NULL,0 );
			ASSERT(!FAILED(hr));
		}
		else
		{
			AfxMessageBox(_T("ϊJnItZbgI[fBI̍ĐԂ𒴂Ă܂\nI[fBI͕ϊ܂"),MB_ICONEXCLAMATION);
			
			//I[fBI͖gp
			m_bUseAudio = FALSE;
		}

		//{_OGW̃CX^X쐬
		//
		//̃_OGW^CC𗘗pĂ
		//ϊ邽߂̃tB^̐ڑȂǂbĂ܂
		hr = CoCreateInstance(CLSID_RenderEngine,
							NULL,CLSCTX_INPROC_SERVER,
							IID_IRenderEngine,(void**)&pRenderEngine);
		if(FAILED( hr )) 
		{
			AfxMessageBox(_T("{_OGW̃CX^X쐬Ɏs܂"),MB_ICONSTOP);
			break;
		}

		//_OGWɃ^CCZbg
		hr = pRenderEngine->SetTimelineObject(pTimeline);
		
		if(FAILED( hr )) 
		{
			AfxMessageBox(_T("_OGWւ̃^CCZbgɎs܂"),MB_ICONSTOP);
			break;
		}

		//rfIƃI[fBI̊eO[v̏o̓s܂ł
		//tB^ڑ܂B
		//
		//̏o̓sVideoRendererAudioRendererɐڑ
		//Ɖʂł̍Đ\ŁAMuxtB^FileWriter
		//ɐڑƃt@Cɏo͂邱Ƃł܂B
		//̃AvP[Vł͌҂̃t@Co͂ړI
		//Ă܂B
		hr = pRenderEngine->ConnectFrontEnd();

		if(FAILED( hr )) 
		{
			AfxMessageBox(_T("tgGh̍\zɎs܂"),MB_ICONSTOP);
			break;
		}

		//ŐڑeO[v̏o̓š̃tB^Ǘ
		//߂̃tB^Otr_[̃CX^X쐬
		//
		//̃tB^Otr_[PMFp̕ϊMuxtB^
		//ǉA^CC̃O[vFileWriter܂łڑ
		//邱ƂɂAt[[gϊƃtH[}bgϊ
		//CɍsOt쐬܂B
		CComPtr<ICaptureGraphBuilder2> pBuilder;
		CoCreateInstance(CLSID_CaptureGraphBuilder2, NULL, CLSCTX_INPROC, 
						IID_ICaptureGraphBuilder2, (void **)&pBuilder);

		//^CCō쐬ꂽOt擾B
		pRenderEngine->GetFilterGraph(&pGraph);
		pBuilder->SetFiltergraph(pGraph);		//tB^Otr_[ɓo^

	#ifdef _DEBUG
		SaveGraphFile(pGraph,L"TimeLine.grf");
	#endif //_DEBUG

		//==========================================================================
		//PMFϊp̃tB^[Ot쐬
		//==========================================================================

		//P/ECE Gray ConvertorOtɒǉ
		CComPtr< IBaseFilter > pPieceGrayConv;
		hr = AddFilterByCLSID(pGraph,CLSID_PieceGrayConv,PIECE_GRAY_CONV,&pPieceGrayConv);
		if(FAILED(hr))
		{
			AfxMessageBox(_T("P/ECE Gray ConvertortB^̒ǉɎs܂"),MB_ICONSTOP);
			break;
		}

		//P/ECE ADPCM ConvertorOtɒǉ
		CComPtr< IBaseFilter > pPieceADPCMConv;
		hr = AddFilterByCLSID(pGraph,CLSID_PieceADPCMConv,PIECE_ADPCM_CONV,&pPieceADPCMConv);
		if(FAILED(hr))
		{
			AfxMessageBox(_T("P/ECE ADPCM ConvertortB^̒ǉɎs܂"),MB_ICONSTOP);
			break;
		}

		//P/ECE Movie File MuxOtɒǉ
		CComPtr< IBaseFilter > pPieceMovieFileMux;
		hr = AddFilterByCLSID(pGraph,CLSID_PieceMovieFileMux,PIECE_MOVIE_FILE_MUX,&pPieceMovieFileMux);
		if(FAILED(hr))
		{
			AfxMessageBox(_T("P/ECE Movie File MuxtB^̒ǉɎs܂"),MB_ICONSTOP);
			break;
		}

		//File WritertB^Otɒǉ
		CComPtr< IFileSinkFilter2 > pFileWriter;
		
		//܂IID_IFileSinkFilter2C^[tF[XƂč쐬
		hr = CoCreateInstance(CLSID_FileWriter, NULL, CLSCTX_INPROC,
							  IID_IFileSinkFilter2,(void **)&pFileWriter);
		if(FAILED(hr))
		{
			AfxMessageBox(_T("File WritertB^̍쐬Ɏs܂"),MB_ICONSTOP);
			break;
		}

		//IID_IBaseFilterC^[tF[X擾
		CComQIPtr< IBaseFilter, &IID_IBaseFilter > pWriterBase(pFileWriter);
		
		//tB^ɒǉ
		hr = pGraph->AddFilter(pWriterBase,L"File Writer");
		if(FAILED(hr))
		{
			AfxMessageBox(_T("File WritertB^̒ǉɎs܂"),MB_ICONSTOP);
			break;
		}
		
		//File WritertB^ɏo̓t@CZbg
		TCHAR *ptOutFilename = sOutputPath.GetBuffer(MAX_PATH);
		WCHAR *pwOutFilename = T2W(ptOutFilename);
	    
		pFileWriter->SetFileName(pwOutFilename,NULL);
		
		//^CCOt̊eO[vo̓s擾
		CComPtr<IPin> pVideoGroupOutPin = NULL;
		CComPtr<IPin> pAudioGroupOutPin = NULL;
		long NumGroups;
		pTimeline->GetGroupCount(&NumGroups);	//^CC̃O[v擾

		//O[v[vAo̓s擾B
		for(i = 0;i < NumGroups;++i)
		{
			//O[v̏o̓s擾
			IPin *pPin;
			if(pRenderEngine->GetGroupOutputPin(i,&pPin) == S_OK) 
			{
				//s̃fBA^Cv`FbN
				CComPtr<IEnumMediaTypes> pEnumMedia;
				if(pPin->EnumMediaTypes(&pEnumMedia) == S_OK)
				{
					ULONG Fetched = 0;
					AM_MEDIA_TYPE *pMediaType;			
        			if(pEnumMedia->Next(1,&pMediaType,&Fetched) == S_OK)
					{
						if(Fetched)
						{
							//s擾
							if(pMediaType->majortype == MEDIATYPE_Video)
								pVideoGroupOutPin = pPin;
							else if(pMediaType->majortype == MEDIATYPE_Audio)
								pAudioGroupOutPin = pPin;
						}
						FreeMediaType(*pMediaType);	//Yꂸ
					}
				}

				pPin->Release();	//Yꂸ
			}
		}

		//etB^̓/o̓s擾
		CComPtr<IPin> pVideoIn    = GetInPin (pPieceGrayConv,    0); 
		CComPtr<IPin> pVideoOut   = GetOutPin(pPieceGrayConv,    0);
		CComPtr<IPin> pAudioIn    = GetInPin (pPieceADPCMConv,   0);
		CComPtr<IPin> pAudioOut   = GetOutPin(pPieceADPCMConv,   0);
		CComPtr<IPin> pMuxVideoIn = GetInPin (pPieceMovieFileMux,0);
		CComPtr<IPin> pMuxAudioIn = GetInPin (pPieceMovieFileMux,1);
		CComPtr<IPin> pMuxOut     = GetOutPin(pPieceMovieFileMux,0);
		CComPtr<IPin> pWriterIn   = GetInPin (pWriterBase,       0);
				
		//rfIO[v̏o̓sP/ECE Gray Convertorڑ
		//CeWFgڑɂAIɊԂɕKvȃtB^
		//}܂B
		hr = pGraph->Connect(pVideoGroupOutPin,pVideoIn);
		if(FAILED(hr))
		{
			AfxMessageBox(_T("rfIO[v̏o̓sP/ECE Gray ConvertortB^Ƃ̃sڑɎs܂"),MB_ICONSTOP);
			break;
		}
		
		//P/ECE Gray ConvertorP/ECE@Movie File Muxڑ
		//CeWFgڑɂAIɊԂɕKvȃtB^
		//}܂B
		hr = pGraph->Connect(pVideoOut,pMuxVideoIn);
		if(FAILED(hr))
		{
			AfxMessageBox(_T("P/ECE Gray ConvertortB^P/ECE Movie File MuxtB^Ƃ̃sڑɎs܂"),MB_ICONSTOP);
			break;
		}
		
		//I[fBIO[v̏o̓s݂͑邩H
		if(m_bUseAudio)
		{
  			//I[fBIO[v̏o̓sP/ECE ADPCM Convertorڑ
			//CeWFgڑɂAIɊԂɕKvȃtB^
			//}܂B
			hr = pGraph->Connect(pAudioGroupOutPin,pAudioIn);
			if(FAILED(hr))
			{
				AfxMessageBox(_T("I[fBIO[v̏o̓sP/ECE ADPCM ConvertorƂ̃sڑɎs܂"),MB_ICONSTOP);
				break;
			}

			//P/ECE ADPCM ConvertorP/ECE@Movie File Muxڑ
			//CeWFgڑɂAIɊԂɕKvȃtB^
			//}܂B
			hr = pGraph->Connect(pAudioOut,pMuxAudioIn);
			if(FAILED(hr))
			{
				AfxMessageBox(_T("P/ECE ADPCM ConvertortB^P/ECE Movie File MuxtB^Ƃ̃sڑɎs܂"),MB_ICONSTOP);
				break;
			}
		}
		

		//P/ECE@Movie File MuxFile Writerڑ
		//CeWFgڑɂAIɊԂɕKvȃtB^
		//}܂B
		hr = pGraph->Connect(pMuxOut,pWriterIn);
		if(FAILED(hr))
		{
			AfxMessageBox(_T("P/ECE Movie File MuxtB^File WritertB^Ƃ̃sڑɎs܂"),MB_ICONSTOP);
			break;
		}
			
		//tB^Otp̃C^[tF[X擾
		CComQIPtr< IMediaControl, &IID_IMediaControl > pControl(pGraph);
		CComQIPtr< IMediaSeeking, &IID_IMediaSeeking > pSeeking(pGraph);
		CComQIPtr< IMediaEvent,   &IID_IMediaEvent >   pEvent(pGraph);
		CComQIPtr< IMediaFilter,  &IID_IMediaFilter >  pMF(pGraph);

		//NbN𖳎āAo邾_O悤
		//Otɒʒm
		hr = pMF->SetSyncSource(NULL);
		if(FAILED(hr))
		{
			AfxMessageBox(_T("SetSyncSource(NULL)ʒmɎs"),MB_ICONEXCLAMATION);
		}

	#ifdef _DEBUG
		SaveGraphFile(pGraph,L"Conversion.grf");
	#endif //_DEBUG

		//V[N@\̖₢킹
		DWORD dwCaps=0;
		hr = pSeeking->GetCapabilities(&dwCaps);
		if(FAILED(hr))
		{
			AfxMessageBox(_T("V[N@\̖₢킹Ɏs܂"),MB_ICONEXCLAMATION);
			//break;	//V[N@\ȂĂƂ肠͓̂Őɐi߂܂		
		}
	    
		//V[Ñ^CtH[}bgݒ
		//pSeeking->SetTimeFormat(&TIME_FORMAT_MEDIA_TIME);
		
		//o͐t@C폜
		DeleteFile(sOutputPath);

		//PieceGrayConvtB^̎RgXgtO
		//K}␳tOݒ
		CComQIPtr< IPieceGrayConv, &IID_IPieceGrayConv > pPieceGrayConvInterface(pPieceGrayConv);
		pPieceGrayConvInterface->put_AutoContrastFlag(m_bAutoContrast);
		pPieceGrayConvInterface->put_GammaCorrectFlag(m_bGammaCorrect);

		//ϊς݂̃t[m邽߂PieceMovieFileMux
		//C^[tF[X擾
		CComQIPtr< IPieceMovieFileMux, &IID_IPieceMovieFileMux > pPieceMovieFileMuxInterface(pPieceMovieFileMux);

		//ϊJn
		hr = pControl->Run();
		if(FAILED(hr))
		{
			AfxMessageBox(_T("ϊJnɎs܂"),MB_ICONSTOP);
			break;
		}

		//ϊI҂[v
		DWORD dwStratTime = GetTickCount();	//Jnۑ
		while(1)
		{
			long EvCode = 0;

			//ϊIH(Ԃ擾)
			hr = pEvent->WaitForCompletion(100,&EvCode);

			//̃bZ[W
			PumpMessages();

			//AvIH
			if(m_bCloseRequested)
				break;

			//قƂ́ApSeekingϊ̐i󋵂킩͂Ȃ̂łA
			//Ȃ肭ϊ̈ʒu擾邱ƂłȂ̂ŁAƂ肠
			//AĂ邱Ƃ߂ɕϊJňoߎԂ\
			ShowProcessTime("ϊc",(int)(GetTickCount() - dwStratTime) / 1000);

			//2005/07/31 Added by Madoka
			//PieceMovieFileMuxtB^ϊς݂̃t[擾A
			//݂̐is󋵂vOXo[ŕ\
			DWORD dwFrame;
			pPieceMovieFileMuxInterface->get_ConvertedFrameCount(&dwFrame);
			m_Progress.SetPos(dwFrame * 100 / m_dwTotalFrames);

			//ϊIĂ甲
			if(EvCode != 0)
				break;
		}

		//mɎ~߂
		pControl->Stop();

		//2005/07/31 Added by Madoka
		//ϊ󋵃vOXo[100%
		m_Progress.SetPos(100);
		Sleep(500);	//100%

		//ϊbZ[W\
		ShowProcessTime("ϊI!!",(int)(GetTickCount() - dwStratTime) / 1000);
		
		//Œm点
		MessageBeep(0);
	
	}while(0);

	//2005/07/31 Added by Madoka
	//ϊ󋵃vOXo[\
	m_Progress.ShowWindow(SW_HIDE);

	//t@C̃hbvtĊJ
	DragAcceptFiles(TRUE);
	
	//o͐tH_ύX{^𗘗p\
	GetDlgItem(IDC_BUTTON_OUTDIR)->EnableWindow(TRUE);

	//ϊJn{^𗘗p\
	GetDlgItem(IDC_BUTTON_RUN)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_AUTO_CONTRAST)->EnableWindow(TRUE);	//2005/07/24 Added by Madoka
	GetDlgItem(IDC_CHECK_GAMMA_CORRECT)->EnableWindow(TRUE);	//2005/07/27 Added by Madoka

}

int CALLBACK BrowseCallbackProc(HWND hWnd,UINT uMsg,LPARAM lParam, LPARAM lpData)
{
	//tH_ĨR[obN

	switch (uMsg)
    {
		//
        case BFFM_INITIALIZED:
            // wParam  TRUE  ȂpX
            //           FALSE Ȃpidl
			::SendMessage(hWnd,BFFM_SETSELECTION,TRUE,lpData);
            break;
        default:
            break;
    }
    return 0;
}

void CPMF_ConvertorDlg::OnBnClickedButtonOutdir()
{
	//o͐tH_ύX

	//tH_I_CAOJ
	BROWSEINFO tBrowsInfo;
	TCHAR szDisplayName[MAX_PATH+1];
	TCHAR szDir[MAX_PATH+1];
	LPITEMIDLIST pidl;
	LPMALLOC pMalloc;

	//Shell̕WAP[^(IMallocC^[tF[X)擾
	if(SUCCEEDED(SHGetMalloc(&pMalloc)))
	{
		ZeroMemory(&tBrowsInfo,sizeof(tBrowsInfo));
		tBrowsInfo.hwndOwner      = m_hWnd;								//I[i[EChẼnh
		tBrowsInfo.pidlRoot       = CSIDL_DESKTOP;						//[gtH_\IDXgւ̃|C^
		tBrowsInfo.pszDisplayName = szDisplayName;						//[UIACe̕\i[obt@w
		tBrowsInfo.lpszTitle      = "PMFt@C̏o͐tH_IĂ";	//^Cg
		tBrowsInfo.ulFlags        = BIF_RETURNONLYFSDIRS;				//tO
		tBrowsInfo.lpfn           = (BFFCALLBACK)BrowseCallbackProc;    //R[obN֐w肵܂
		tBrowsInfo.lParam         = (LPARAM)(LPCTSTR)m_sOutputDir;		//ftHgItH_̎w
		
		//tH_I_CAO̕\
		pidl = SHBrowseForFolder(&tBrowsInfo);

		//IꂽH
		if(pidl)
		{
			//IDXgpXɕϊ
			if(SHGetPathFromIDList(pidl,szDir))
			{
				//pX̍Ō'\'菜
				//o͐tH_ƂāAhCu̒w肵ꍇ
				//"C:\"Ƃ悤ɍŌ'\'Ă܂̂ŁA
				//菜܂BhCuȉ̃tH_w肵ꍇ
				//͍Ō'\'͕t܂B
				TCHAR *pYen = _tcschr(szDir,'\0');	//̍Ō̃|C^擾
				pYen = _tcsdec(szDir,pYen);			//1߂
				if(_tcscmp(pYen,_T("\\")) == 0)
					_tcsncpy(pYen,_T("\0"),1);

				//o͐tH_̃pXۑ
				m_sOutputDir = szDir;

				//t@C̕ۑ
				SaveSetting();				

				//t@C̕\
				SetFileInfo();
			}

			//IDXg̍폜
			pMalloc->Free(pidl);
		}

		//AP[^̉
		pMalloc->Release();
	}
}

void CPMF_ConvertorDlg::OnClose()
{
	// TODO : ɃbZ[W nh R[hǉ邩ȀĂяo܂B

	//Iv
	m_bCloseRequested = TRUE;

	//o̓IvV擾
	GetOutOptionValue();

	//t@C̕ۑ
	SaveSetting();				

	CDialog::OnClose();
}


BOOL CPMF_ConvertorDlg::PreTranslateMessage(MSG* pMsg)
{
	// TODO : ɓȃR[hǉ邩A͊{NXĂяoĂB

	//c[qgRg[Ƀ}EXbZ[Wn
	m_tooltip.RelayEvent(pMsg);

	return CDialog::PreTranslateMessage(pMsg);
}

void CPMF_ConvertorDlg::OnBnClickedCheckOutSampleLen()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B

	//ϊ`FbNNbNꂽ

	//`FbNɂĂϊԂ̃R{{bNX𐧌
	CButton *pCheck = (CButton*)GetDlgItem(IDC_CHECK_OUT_SAMPLE_LEN);
	GetDlgItem(IDC_COMBO_SAMPLE_LEN)->EnableWindow(pCheck->GetCheck());

}

void CPMF_ConvertorDlg::OnEnChangeEditOutOffset()
{
	// TODO :  ꂪ RICHEDIT Rg[̏ꍇA܂ACDialog::OnInitDialog() ֐I[o[ChāA
	// OR Ԃ ENM_CORRECTTEXT tO}XNɓāA
	// CRichEditCtrl().SetEventMask() ĂяoȂA
	// Rg[́A̒ʒm𑗐M܂B

	// TODO :  ɃRg[ʒmnh R[hǉĂB

	//ϊJnItZbgύXꂽ
	
	//2005/04/08 Add by Madoka
	//SetDlgItemIntĂ܂ƁA܂OnEnChangeEditOutOffset
	//(̃Cxgnh)āAċAIɌĂяoĂ܂̂
	//̂悤ɂāA[UύXꍇ̂ݒlʂɔf悤
	//CB
	//̃oÓAWin2000 & XPł͂łȂ悤AWin98nł͋N
	//X^bNG[ƂȂ(ċAIɌĂяoꂽX^bNG[
	//Ȃ(- -;)
	//
	//[U[̑ɂ̂ݔ
	if(!m_bInternalEdit)
	{
		//͒l̎擾
		int nValue = GetDlgItemInt(IDC_EDIT_OUT_OFFSET);

		//
		if(nValue > START_OFFSET_MAX)
			nValue = START_OFFSET_MAX;

		//Jn
		m_bInternalEdit = TRUE;

		//ēxݒ
		SetDlgItemInt(IDC_EDIT_OUT_OFFSET,nValue);

		//LbgE[ɏC
		CEdit *pEdit = (CEdit*)GetDlgItem(IDC_EDIT_OUT_OFFSET);
		pEdit->SetSel(pEdit->LineLength(),-1);

		//I
		m_bInternalEdit = FALSE;
	}
}
